## org.apache.mahout.cf.taste.impl.recommender.svd
Class ExpectationMaximizationSVD

    java.lang.Object
      org.apache.mahout.cf.taste.impl.recommender.svd.ExpectationMaximizationSVD

    public final class ExpectationMaximizationSVD

extends java.lang.Object

Calculates the SVD using an Expectation Maximization algorithm.

Constructor Summary
`ExpectationMaximizationSVD(int m, int n, int k, double defaultValue)`
`ExpectationMaximizationSVD(int m, int n, int k, double defaultValue, double noise)`

Method Summary
`double` `getDotProduct(int i, int j)`
`void` `train(int i, int j, int k, double value)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ExpectationMaximizationSVD

    public ExpectationMaximizationSVD(int m,
                                      int n,
                                      int k,
                                      double defaultValue)

Parameters:
  `m` - number of columns
  `n` - number of rows
  `k` - number of features
  `defaultValue` - default starting values for the SVD vectors

### ExpectationMaximizationSVD

    public ExpectationMaximizationSVD(int m,
                                      int n,
                                      int k,
                                      double defaultValue,
                                      double noise)

Method Detail

### getDotProduct

    public double getDotProduct(int i,
                                int j)

### train

    public void train(int i,
                      int j,
                      int k,
                      double value)

Copyright © 2008-2010 The Apache Software Foundation. All Rights Reserved.